// OpenGLWnd.cpp : implementation file
//

#include "stdafx.h"
#include "Globe.h"
#include "OpenGLWnd.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpenGLWnd

COpenGLWnd::COpenGLWnd()
{
    m_xrot  = 0.0;   // X Rotation
    m_yrot  = 0.0;   // Y Rotation
    m_zPos  = 0.0;   // Z Position
    m_xspeed= 0.0;   // X Rotation Speed
    m_yspeed= 0.0;   // Y Rotation Speed

    IsRMouseDown = FALSE;

}

COpenGLWnd::~COpenGLWnd()
{
}


BEGIN_MESSAGE_MAP(COpenGLWnd, CStatic)
	//{{AFX_MSG_MAP(COpenGLWnd)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpenGLWnd message handlers

void COpenGLWnd::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
    glClearColor(0,0,0,0);
	glColor3f(1, 1, 1);

	if (hglrc)
	{ 
        // try to make it the thread's current rendering context 
        if(wglMakeCurrent(hdc, hglrc))
		{
 			//render here
            glDraw();
        } 
    }  
}

BOOL COpenGLWnd::OnEraseBkgnd(CDC* pDC) 
{
	return TRUE;
	
//	return CStatic::OnEraseBkgnd(pDC);
}

int COpenGLWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CStatic::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
    hdc = ::GetDC(m_hWnd);
	GLSetPixelFormat(hdc);
	
	return 0;
}

void COpenGLWnd::glDraw()
{
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);    // Clear The Screen And The Depth Buffer
    glLoadIdentity();                                       // Reset The View

    glTranslatef(0.0,0.0,m_zPos);
    glRotatef(15, 1.0, 0.0, 0.0);
    glRotatef(m_xrot, 1.0, 0.0, 0.0);
    glRotatef(m_yrot, 0.0, 1.0, 0.0);

    glBindTexture(GL_TEXTURE_2D, DayTex);

    glCallList(SphereDL);

    m_xrot = m_xrot + m_xspeed;
    m_yrot = m_yrot + m_yspeed;

    SwapBuffers(hdc);
}

int COpenGLWnd::GLSetPixelFormat(HDC hdc)
{
	PIXELFORMATDESCRIPTOR pfd = { 
	    sizeof(PIXELFORMATDESCRIPTOR),    // size of this pfd 
	    1,                                // version number 
	    PFD_DRAW_TO_WINDOW |              // support window 
	    PFD_SUPPORT_OPENGL |              // support OpenGL 
	    PFD_DOUBLEBUFFER,                 // double buffered 
	    PFD_TYPE_RGBA,                    // RGBA type 
	    24,                               // 24-bit color depth 
	    0, 0, 0, 0, 0, 0,                 // color bits ignored 
	    0,                                // no alpha buffer 
	    0,                                // shift bit ignored 
	    0,                                // no accumulation buffer 
	    0, 0, 0, 0,                       // accum bits ignored 
	    32,                               // 32-bit z-buffer     
	    0,                                // no stencil buffer 
	    0,                                // no auxiliary buffer 
	    PFD_MAIN_PLANE,                   // main layer 
	    0,                                // reserved 
	    0, 0, 0                           // layer masks ignored 
	}; 
	
	int  iPixelFormat; 
 
	// get the device context's best, available pixel format match 
	if((iPixelFormat = ChoosePixelFormat(hdc, &pfd)) == 0)
	{
		AfxMessageBox("ChoosePixelFormat Failed");
		return 0;
	}
	 
	// make that match the device context's current pixel format 
	if(SetPixelFormat(hdc, iPixelFormat, &pfd) == FALSE)
	{
		AfxMessageBox("SetPixelFormat Failed");
		return 0;
	}

	return 1;
}


void COpenGLWnd::glInit()
{
    hglrc = wglCreateContext(hdc);
    if( !wglMakeCurrent(hdc, hglrc) )
    {
        AfxMessageBox("Fail to make currect wg!");
        return;
    }

    if( !LoadGLTextures("res/earth.bmp", &DayTex) )
    {
        AfxMessageBox("Fail to make currect wg!");
        return;
    }

    glEnable(GL_TEXTURE_2D);          // Enable Texture Mapping
    glClearColor(0.0, 0.0, 0.0, 0.0); 	   // Black Background
    glShadeModel(GL_SMOOTH);                 // Enables Smooth Color Shading
    glClearDepth(1.0);                       // Depth Buffer Setup
    glEnable(GL_DEPTH_TEST);                 // Enable Depth Buffer
    glDepthFunc(GL_LESS);		           // The Type Of Depth Test To Do

    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);   //Realy Nice perspective calculations

//    m_xspeed =0.1f;
    m_yspeed =0.5f;


    CreateSphere(0, 0, 0, 12.2, 48);

//    CreateSphere(0, 0, 0, 10, 48);
    m_zPos =-32.0f;

//    wglMakeCurrent(NULL, NULL) ; 
//    ::ReleaseDC (m_hWnd, hdc) ; 
}

void COpenGLWnd::glResizeWnd(int Width, int Height)
{
//    wglMakeCurrent(hdc, hglrc);

    if (Height == 0)                    // prevent divide by zero exception
        Height = 1;

    glViewport(0, 0, Width, Height);    // Set the viewport for the OpenGL window
    glMatrixMode(GL_PROJECTION);        // Change Matrix Mode to Projection
    glLoadIdentity();                   // Reset View
    gluPerspective(45.0, Width/Height, 1.0, 100.0);  // Do the perspective calculations. Last value = max clipping depth

    glMatrixMode(GL_MODELVIEW);         // Return to the modelview matrix
    glLoadIdentity();                   // Reset View

//    wglMakeCurrent(NULL, NULL) ; 
//	::ReleaseDC (m_hWnd, hdc) ; 

}

AUX_RGBImageRec* COpenGLWnd::LoadBMP(char *Filename)
{
    FILE *File=NULL;								// File Handle
    if (!Filename)									// Make Sure A Filename Was Given
    {
            return NULL;							// If Not Return NULL
    }
    File=fopen(Filename,"r");						// Check To See If The File Exists
    if (File)										// Does The File Exist?
    {
		fclose(File);								// Close The Handle
		return auxDIBImageLoad(Filename);			// Load The Bitmap And Return A Pointer
    }
    return NULL;									// If Load Failed Return NULL
}

BOOL COpenGLWnd::LoadGLTextures(char *Filename, GLuint *TextureId)
{
    BOOL Status;								// Status Indicator
    AUX_RGBImageRec *TextureImage[1];				// Create Storage Space For The Textures
    memset(TextureImage,0,sizeof(void *)*1);		// Set The Pointer To NULL

    Status = FALSE;
    if(TextureImage[0]=LoadBMP(Filename))	// Load Particle Texture
    {
		Status=TRUE;								// Set The Status To TRUE
		glGenTextures(1, TextureId);				// Create One Texture

		glBindTexture(GL_TEXTURE_2D, *TextureId);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
    }

    if(TextureImage[0])							// If Texture Exists
	{
		if(TextureImage[0]->data)					// If Texture Image Exists
		{
			free(TextureImage[0]->data);			// Free The Texture Image Memory
		}
		free(TextureImage[0]);						// Free The Image Structure
	}
    return Status;									// Return The Status
}

void COpenGLWnd::CreateSphere(GLfloat CX,
                              GLfloat CY,
                              GLfloat CZ,
                              GLfloat Radius,
                              int Precision) 
{
    int i, j;
    float theta1,theta2,theta3;
    float x, y, z, px, py, pz, tex_x, tex_y;

#define PI 3.1415926

    SphereDL =glGenLists(1);
    glNewList(SphereDL, GL_COMPILE);

    if( Radius < 0 ) 
        Radius =-Radius;

    if( Precision < 0 )
        Precision = -Precision;

    if( Precision < 4 || Radius <= 0 )
    {
        glBegin(GL_POINTS);
        glVertex3f(CX, CY, CZ);
        glEnd();
        
        glEndList();
        return;
    }

    for( j = 0; j <= Precision/2 - 1; j++ )
    {
        theta1 = j*2*PI/Precision - PI/2;
        theta2 = (j+1)*2*PI/Precision - PI/2;
        
        glBegin(GL_QUAD_STRIP);
        for(i = 0; i <= Precision; i++ )
        {
            theta3 = i*2*PI/Precision;

            x = cos(theta2) * cos(theta3);
            y = sin(theta2);
            z = cos(theta2) * sin(theta3);
            px = CX + Radius*x;
            py = CY + Radius*y;
            pz = CZ + Radius*z;

            tex_x = 1.0f-(float)i/Precision;
            tex_y = 2.0*(j+1.0)/Precision;

            glTexCoord2f(tex_x, tex_y);
            glVertex3f(px,py,pz);

            x = cos(theta1) * cos(theta3);
            y = sin(theta1);
            z = cos(theta1) * sin(theta3);
            px = CX + Radius*x;
            py = CY + Radius*y;
            pz = CZ + Radius*z;

            tex_x = 1.0f-(float)i/Precision;
            tex_y = 2.0*j/Precision;

            glTexCoord2f(tex_x, tex_y);
            glVertex3f(px,py,pz);
        }
        glEnd();
    }
    
    glEndList();
}



void COpenGLWnd::OnMouseMove(CPoint point) 
{
    if( IsRMouseDown )
        SetOffsetAngle(point.y-BasePoint.y,point.x-BasePoint.x);
}

void COpenGLWnd::OnRButtonDown(CPoint point) 
{
	IsRMouseDown = TRUE;
	
	BasePoint = point;
}

void COpenGLWnd::OnRButtonUp(CPoint point) 
{
	IsRMouseDown = FALSE ;
	::ReleaseCapture();
}

void COpenGLWnd::SetOffsetAngle(int x, int y)
{
    m_xrot = m_xrot + x/50.0;
    m_yrot = m_yrot + y/50.0;
}
