#if !defined(AFX_OPENGLWND_H__16E81576_AEF4_4F3D_A310_992DE09BDE90__INCLUDED_)
#define AFX_OPENGLWND_H__16E81576_AEF4_4F3D_A310_992DE09BDE90__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// OpenGLWnd.h : header file
//
#include <gl/gl.h>
#include <gl/glu.h>
#include <gl\glaux.h>				// Header File For The Glaux Library

/////////////////////////////////////////////////////////////////////////////
// COpenGLWnd window

class COpenGLWnd : public CStatic
{
// Construction
public:
	COpenGLWnd();

// Attributes
public:
	HGLRC hglrc;
    HDC hdc;

	UINT m_nTimerId;

    GLuint DayTex ;
    GLuint SphereDL;  // Sphere Display List
    GLfloat m_xrot ;   // X Rotation
    GLfloat m_yrot ;   // Y Rotation
    GLfloat m_zPos ;   // Z Position
    GLfloat m_xspeed;   // X Rotation Speed
    GLfloat m_yspeed;   // Y Rotation Speed

    BOOL IsRMouseDown;
    CPoint BasePoint;

// Operations
public:
	void glDraw();
	void glResizeWnd(int Width, int Height);
	void glInit();
	int GLSetPixelFormat(HDC hdc);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COpenGLWnd)
	//}}AFX_VIRTUAL

// Implementation
public:
	void OnMouseMove(CPoint point);
	void OnRButtonDown(CPoint point);
	void OnRButtonUp(CPoint point);

    void SetOffsetAngle(int x, int y);
	void CreateSphere(GLfloat CX,
                      GLfloat CY,
                      GLfloat CZ,
                      GLfloat Radius,
                      int N);
	BOOL LoadGLTextures(char *Filename, GLuint *TextureId);
	AUX_RGBImageRec* LoadBMP(char *Filename);
	virtual ~COpenGLWnd();

	// Generated message map functions
protected:
	//{{AFX_MSG(COpenGLWnd)
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPENGLWND_H__16E81576_AEF4_4F3D_A310_992DE09BDE90__INCLUDED_)
